--- 
-- This page will provide documentation for the syntax of a "rotation definition 
-- file". A rotation definition file is valid Lua, and therefore all of the
-- control structures and other language features are valid in a definition file.
-- However, there are some extra functions that have been added in order to make
-- life a little bit easier for people with limited knowledge of Lua. This page 
-- will show you the syntax of these extra functions and what they mean.
--
-- All definition files follow a basic layout and this layout must be followed.
-- @class file

local function InCombat()
end;

local function OutOfCombat()
end;

---
-- Checks to see whether or not the player has 
local function HasPet()
    hasPetUI, isHunterPet = HasPetUI();
    return hasPetUI;
end;

local function PetHealth()
    local currHP = UnitHealth("pet");
    local maxHP = UnitHealthMax("pet");
    local result = math.ceil((currHP / maxHP) * 100);
    return result;
end;

local function TargetHasBuff(name)
    if (UnitExists("target")) then
        local name, rank, icon, count, dispelType, duration, expires, caster, isStealable = UnitBuff("target", name);
    end;
    if (name) then
        return 1;
    else 
        return nil;
    end;
end;

local function TargetHasDebuff()
    if (UnitExists("target")) then
        local name = UnitDebuff("target", "name");
    end;
    if (name) then
        return true;
    else
        return false;
    end;
end;

local function PlayerHasBuff()
end;

local function PlayerHasDebuff()
end;

local function Castable()
end;

local function HasGlyph()
end;

local function Alternative()
end;

local function Cliptime()
end;

local function KnowSpell()
end;

local function HasTalent()
end;

local function OnGCD()
end;

local function LastCast()
end;

local function PetExists()
end;

local function TargetHealth()
end;

local function PlayerHealth()
end;

local function Threat()
end;

local function TargetType()
end;

local function IsBoss()
end;

local function MxBuff()
end;

local function MxDebuff()
end;

local function MxBuffByMe()
end;

local function MxDebuffByMe()
end;